﻿package no.ekse.achtung 
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	import no.ekse.mooses.MoosesPlayer;
	import no.ekse.mooses.MoosesUnit
	import no.ekse.mooses.MoosesFrameworkClient;
	
	/**
	 * ...
	 * @author ...
	 */
	public class AchtungPlayer extends Sprite implements MoosesUnit
	{
		[Embed(source='res/player.png')]
		private static const playerGfx:Class;
		
		[Embed(source='res/snakehead.png')]
		private static const playerHeadGfx:Class;
		
		private var playerSprite:Bitmap;
		private var playerHeadSprite:Bitmap;
		
		private var keyLeft:Boolean = false;
		private var keyRight:Boolean = false;
		
		private var direction:Number = 0;
		
		private var color:uint;
		private var colorTransform:ColorTransform;
		
		private var playerName:String = "Idiot";
		private var playerPoints:int = 0;
		private var playerAlive:Boolean = true;
		
		private var world:AchtungWorld;
		
		private var moosesPlayer:MoosesPlayer;
		
		public function getMoosesPlayer():MoosesPlayer
		{
			return moosesPlayer;
		}
		
		public function setMoosesPlayer(player:MoosesPlayer):void
		{
			moosesPlayer = player;
		}
		
		public function AchtungPlayer(playerName:String, playerNumber:int, world:AchtungWorld) 
		{
			this.world = world;
			this.playerName = playerName;
			
			playerSprite = new AchtungPlayer.playerGfx();
			playerHeadSprite = new AchtungPlayer.playerHeadGfx();
			
			playerSprite.x = 0;
			playerSprite.y = -16;
			
			addChild(playerSprite);
			
			
			if (playerNumber == 0) {
				color = 0xFFFF0000;
				colorTransform = new ColorTransform(1, 0, 0);
			} else if (playerNumber == 1) {
				color = 0xFF3251FF;
				colorTransform = new ColorTransform(50 / 255.0 , 81 / 255.0, 1);
			} else if (playerNumber == 2) {
				color = 0xFF00FF21;
				colorTransform = new ColorTransform(0, 1, 33 / 255.0);
			} else if (playerNumber == 3) {
				color = 0xFFFF00DC;
				colorTransform = new ColorTransform(240 / 255.0, 0, 220 / 255.0);
			} else if (playerNumber == 4) {
				color = 0xFFFFD800;
				colorTransform = new ColorTransform(1, 216 / 255.0, 0);
			} else if (playerNumber == 5) {
				color = 0xFFFF6A00;
				colorTransform = new ColorTransform(1, 106 / 255.0, 0);
			} else if (playerNumber == 6) {
				color = 0xFF00FFD0;
				colorTransform = new ColorTransform(0, 1, 208 / 255.0);
			} else if (playerNumber == 7) {
				color = 0xFFFFFFFF;
				colorTransform = new ColorTransform(1, 1, 1);
			}
			
			playerHeadSprite.bitmapData.lock();
			playerHeadSprite.bitmapData.colorTransform(new Rectangle(0, 0, 16, 16), colorTransform);
			playerHeadSprite.bitmapData.unlock();
		}
		
		public function boink():void
		{
			if (playerAlive) {
				x = x + Math.cos(direction);
				y = y + Math.sin(direction);
				
				if (keyLeft) {
					direction -= 1/20;
				}
				if (keyRight) {
					direction += 1/20;
				}
				
				
				rotation = (direction / Math.PI) * 180;
			}
			//trace(rotation + " " + (rotation / Math.PI) * 360.0);
		}
		public function getColor():uint
		{
			return color;
		}
		public function getBitmap():Bitmap
		{
			return playerHeadSprite;
		}
		public function setDirection(direction:Number):void
		{
			this.direction = direction;
		}
		public function getDirection():Number
		{
			return direction;
		}
		
		public function setPoints(points:Number):void
		{
			this.playerPoints = points;
		}
		public function getPoint():Number
		{
			return playerPoints;
		}
		
		public function setAlive(alive:Boolean):void
		{
			if (playerAlive && alive == false) {
				this.playerAlive = alive;
				removeChild(playerSprite);
				world.awardLivingPlayers();
			}
			if (alive) {
				if (!contains(playerSprite)) {
					addChild(playerSprite);
				}
			}
			this.playerAlive = alive;
		}
		public function isAlive():Boolean
		{
			return playerAlive;
		}
		
		public function setName(name:String):void
		{
			this.playerName = name;
		}
		public function getName():String
		{
			return playerName;
		}
		
		public function allKeysUp():void {
			keyLeft = false;
			keyRight = false;
		}
		public function keyDown(keyId:int):void 
		{
			if (keyId == MoosesFrameworkClient.KEY_4) {
				keyLeft = true;
			} else if (keyId == MoosesFrameworkClient.KEY_6) {
				keyRight = true;
			}
		}
		
		public function keyUp(keyId:int):void 
		{
			if (keyId == MoosesFrameworkClient.KEY_4) {
				keyLeft = false;
			} else if (keyId == MoosesFrameworkClient.KEY_6) {
				keyRight = false;
			}
		}
		
	}

}