﻿package no.ekse.achtung 
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	/**
	 * ...
	 * @author ...
	 */
	public class AchtungStateboard extends Sprite
	{
		[Embed(source='res/state_limbo.png')]
		private static const stateLimboGfx:Class;
		
		[Embed(source='res/state_beginning.png')]
		private static const stateBeginningGfx:Class;
		
		[Embed(source='res/state_over.png')]
		private static const stateOverGfx:Class;
		
		private var boardSprite:Bitmap;
		
		private var stateHeadingFormat:TextFormat;
		private var stateDescriptionFormat:TextFormat;
		private var stateAnnounceFormat:TextFormat;
		
		private var stateHeadingField:TextField;
		private var stateDescriptionField:TextField;
		private var stateAnnounceField:TextField;
		
		public function AchtungStateboard() 
		{
			
			stateHeadingFormat = new TextFormat();
			stateHeadingFormat.font = "Verdana";
			stateHeadingFormat.color = 0xFFFFFF;
			stateHeadingFormat.size = 60;
			
			stateDescriptionFormat = new TextFormat();
			stateDescriptionFormat.font = "Verdana";
			stateDescriptionFormat.color = 0xFFFFFF;
			stateDescriptionFormat.size = 30;
			
			stateAnnounceFormat = new TextFormat();
			stateAnnounceFormat.font = "Verdana";
			stateAnnounceFormat.color = 0xFFFFFF;
			stateAnnounceFormat.size = 100;
			
			stateHeadingField = new TextField();
			stateHeadingField.defaultTextFormat = stateHeadingFormat;
			stateHeadingField.x = 50;
			stateHeadingField.y = 50;
			stateHeadingField.width = 1200;
			
			stateDescriptionField = new TextField();
			stateDescriptionField.defaultTextFormat = stateDescriptionFormat;
			stateDescriptionField.x = 50;
			stateDescriptionField.y = 120;
			stateDescriptionField.width = 1200;
			
			stateAnnounceField = new TextField();
			stateAnnounceField.defaultTextFormat = stateAnnounceFormat;
			stateAnnounceField.x = 50;
			stateAnnounceField.y = 300;
			stateAnnounceField.width = 1200;
			stateAnnounceField.height = 150;
			
			boardSprite = new AchtungStateboard.stateLimboGfx();
			
			
			addChild(boardSprite);
			
			addChild(stateHeadingField);
			addChild(stateDescriptionField);
			addChild(stateAnnounceField);
			
		}
		
		public function updateBoard(state:int, announce:String):void
		{
			if (contains(boardSprite)) {
				removeChild(boardSprite);
			}
			
			trace(state);
			
			if (state == AchtungWorld.STATE_LIMBO) {
				boardSprite = new AchtungStateboard.stateLimboGfx();
				trace("stateboard = limbo " + state);
				stateHeadingField.text = "Limbo";
				stateDescriptionField.text = "Venter på at flere skal koble seg til";
				stateAnnounceField.text = announce;
				//addChild(boardSprite);
			} else if (state == AchtungWorld.STATE_MATCH_BEGINNING) {
				boardSprite = new AchtungStateboard.stateBeginningGfx();
				trace("stateboard = beginning " + state);
				
				stateHeadingField.text = "Runden begynner umiddelbart";
				stateDescriptionField.text = "Gjør dere klare!";
				stateAnnounceField.text = announce;
				//addChild(boardSprite);
			} else if (state == AchtungWorld.STATE_MATCH_OVER) {
				boardSprite = new AchtungStateboard.stateOverGfx();
				trace("stateboard = over " + state);
				
				stateHeadingField.text = "Runden er over";
				stateDescriptionField.text = "";
				stateAnnounceField.text = announce;
				//addChild(boardSprite);
			} else {
				stateHeadingField.text = " ";
				stateDescriptionField.text = " ";
				stateAnnounceField.text = announce;
			}
			
			
			
		}
		
	}

}