﻿package no.ekse.achtung 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.KeyboardEvent;
	import flash.filters.ColorMatrixFilter;
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import no.ekse.mooses.MoosesFrameworkClient;
	import no.ekse.mooses.MoosesPlayer;
	import flash.system.fscommand;
	
	/**
	 * ...
	 * @author ...
	 */
	public class AchtungWorld extends Sprite
	{
		private var main:Main;
		
		[Embed(source='res/snakebackground.png')]
		private static const backgroundGfx:Class;
		private var backgroundSprite:Bitmap;
		
		private var screenWidth:int = 1920;
		private var screenHeight:int = 1080;
		
		
		private var achtungWidth:int = 1920;
		private var achtungHeight:int = 1000;
		
		private var abmd:BitmapData;
		private var abm:Bitmap;
		
		private var tempD:BitmapData;
		private var temp:Bitmap;
		
		private var scoreboard:AchtungScoreboard;
		private var stateboard:AchtungStateboard;
		
		private var players:Array = new Array(0);
		private var numPlayers:Number;
		
		
		
		private var depositing:Boolean = true;
		private var numDeposit:int = 300;
		private var numFree:int = 50;
		
		private var countDeposit:int = 0;
		private var countFree:int = 0;
		
		private var gamestate:int = 0;

		public static var STATE_LIMBO:int = 0;
		public static var STATE_MATCH_BEGINNING:int = 1;
		public static var STATE_MATCH_RUNNING:int = 2;
		public static var STATE_MATCH_OVER:int = 3;
		
		private var stateCounter:int = 0;
		
		private var matchesLeft:int;
		private var roundsDone:int;
		private var matchWinner:String;
		
		public function AchtungWorld(main:Main) 
		{
			this.main = main;
			
			backgroundSprite = new AchtungWorld.backgroundGfx();
			
			addChild(backgroundSprite);
			
			abmd = new BitmapData(achtungWidth, achtungHeight, true);
			abm = new Bitmap();
			
			tempD = new BitmapData(16, 16);
			temp = new Bitmap();
			
			abm.bitmapData = abmd;
			temp.bitmapData = tempD;
			
			addChild(abm);
			
			scoreboard = new AchtungScoreboard(achtungWidth, screenHeight - achtungHeight);
			scoreboard.y = achtungHeight;
			
			addChild(scoreboard);
			
			main.stage.addEventListener(KeyboardEvent.KEY_DOWN, KeyPressed);
			main.stage.addEventListener(KeyboardEvent.KEY_UP, KeyReleased);

			gamestate = STATE_LIMBO;
			stateCounter = 5 * 30;
			
			stateboard = new AchtungStateboard();
			addChild(stateboard);
			
			stateboard.updateBoard(gamestate, "Achtung Die Kurve");
		}
		public function awardLivingPlayers():void
		{
			var p:int = 0;
			var numAlive:int = 0;
			
			trace("--- --- ---");
					
			for (p = 0; p < numPlayers; p++) {
				if ((players[p] as AchtungPlayer).isAlive()) {
					(players[p] as AchtungPlayer).setPoints((players[p] as AchtungPlayer).getPoint() + 5);
					numAlive++;
					matchWinner = (players[p] as AchtungPlayer).getName();
					trace("Point to " + p + ", now has " + (players[p] as AchtungPlayer).getPoint());
				}
			}
			
			trace("-*- -*- -*-");
			
			if (numAlive < 2) {
				stateCounter = 0;
				
				
			}
			
			updateScoreboard();
		}
		
		public function resetGame():void
		{
			var i:int = 0;
				
			for (i = 0; i < numPlayers; i++) {
				(players[i] as AchtungPlayer).setAlive(true);
				
				(players[i] as AchtungPlayer).x = achtungWidth / 2 + (achtungWidth / 2) * Math.cos( Math.PI * 2 * (i / numPlayers) );
				(players[i] as AchtungPlayer).y =  achtungHeight / 2 + (achtungHeight / 2) * Math.sin( Math.PI * 2 * (i / numPlayers) );
				(players[i] as AchtungPlayer).allKeysUp();
				(players[i] as AchtungPlayer).setDirection(Math.PI + Math.PI * 2 * (i / numPlayers));
				
				
			}
			
			updateScoreboard();	
			
			abm.bitmapData.lock();
			abm.bitmapData.fillRect(new Rectangle(0, 0, achtungWidth, achtungHeight), 0x0);
			abm.bitmapData.unlock();
			
		}
		public function updateScoreboard():void
		{
			var i:int = 0;
			var scoreStatus:Array = new Array(0);
				
			for (i = 0; i < numPlayers; i++) {
				scoreStatus.push( (players[i] as AchtungPlayer).getName() );
				scoreStatus.push( (players[i] as AchtungPlayer).getPoint() );
				
				
			}
			
			trace("!!! score update !!!");
			
			scoreboard.updateScoreboard(scoreStatus);
		}
		
		public function transmitScoreData():void
		{
			var i:int = 0;
			var scoreStatus:Array = new Array(0);
				
			for (i = 0; i < numPlayers; i++) {
				trace("sending to p" + i + ", points: " + (players[i] as AchtungPlayer).getPoint());
				((players[i] as AchtungPlayer).getMoosesPlayer() as MoosesPlayer).sendScore( (players[i] as AchtungPlayer).getPoint() );
			}
		
		}
		
		public function resetMatch():void
		{
			var i:int = 0;
			
			if (players.length > 0) {
				for (i = 0; i < numPlayers; i++) {
					if (contains(players[i])) {
						removeChild(players[i]);
					}
				}
			}
			
			players = new Array(0);
			
			var moosesPlayers:Array = main.getPlayerList();
			var v:AchtungPlayer;
			numPlayers = 0;
			/*
			if (Main.DEBUG) {
				*/
			for (i = 0; i < moosesPlayers.length; i++) {
				
				v = new AchtungPlayer((moosesPlayers[i] as MoosesPlayer).getPlayerName(), i, this);
				trace("Adding player " + i + ", " + (moosesPlayers[i] as MoosesPlayer).getPlayerName());
				/*
				main.sendMessage( (moosesPlayers[i] as MoosesPlayer).getPlayerId(), 20, "4 = sving venstre\n6 = sving høyre");
				main.sendMessage( (moosesPlayers[i] as MoosesPlayer).getPlayerId(), 21, "Achtung Die Kurve");
				*/
				(moosesPlayers[i] as MoosesPlayer).attachUnit(v);
				
				players.push( v );
				numPlayers++;
				
				addChild(v);
				
			}
				
			/*} else {
				
				for (i = 0; i < moosesPlayers.length; i++) {
					
					v = new AchtungPlayer((moosesPlayers[i] as MoosesPlayer).getPlayerName(), i, this);
					
					(moosesPlayers[i] as MoosesPlayer).attachUnit(v);
					
					players.push( v );
					numPlayers++;
					
					addChild(v);
					
				}
			}*/
			
			
			
			
		}
		
		public function boink():void
		{
			stateCounter--;
			
			if (stateCounter < 0) {
				gamestate++;
				
				if (gamestate > STATE_MATCH_OVER) {
					gamestate = STATE_MATCH_BEGINNING;
				}
				
				if (gamestate == STATE_MATCH_BEGINNING) {
					stateCounter = 5 * 30;
					matchesLeft--;
					
					if (matchesLeft < 0) {
						roundsDone++;
						
						if (roundsDone > 1) {
							transmitScoreData();
							fscommand("quit");
						}
						
						resetMatch();
						matchesLeft = 2;
						
						if (numPlayers < 2) {
							fscommand("quit");
						}
					}
					
					
					resetGame();
					
					
					trace("Match beginning");
				} else if (gamestate == STATE_MATCH_OVER) {
					
				
					stateCounter = 10 * 30;
					trace("Match over, resetting soon");
					
				} else if (gamestate == STATE_MATCH_RUNNING) {
					
					stateCounter = 15 * 60 * 30;
					trace("Match begun");
				}
				
				if (gamestate == STATE_MATCH_OVER) {
					stateboard.updateBoard(gamestate, matchWinner + " vant!");
					
				} else {
					stateboard.updateBoard(gamestate, " ");
				}
			}
			
			if (gamestate == STATE_MATCH_RUNNING) {
				
				var x:int = 0; var y:int = 0; var p:int = 0;
				
				abm.bitmapData.lock();
				
				if (depositing) {
					/*
					for (p = 0; p < numPlayers; p++) {
						for (x = (players[p] as AchtungPlayer).x - 8; x < (players[p] as AchtungPlayer).x + 8; x++) {
							for (y = (players[p] as AchtungPlayer).y - 8; y < (players[p] as AchtungPlayer).y + 8; y++) {
								if (Math.sqrt(Math.pow(x - (players[p] as AchtungPlayer).x, 2) + Math.pow(y - (players[p] as AchtungPlayer).y, 2)) < 3) {
									abm.bitmapData.setPixel(x, y, (players[p] as AchtungPlayer).getColor());
								}
							}
						}
					}*/
					//temp.bitmapData.lock();
					//temp.bitmapData = new BitmapData(16, 16);												   
					for (p = 0; p < numPlayers; p++) {
						//temp.bitmapData.copyPixels((players[p] as AchtungPlayer).getBitmap().bitmapData, new Rectangle(0, 0, 16, 16), new Point(0, 0));
						//temp.bitmapData.colorTransform(new Rectangle(0, 0, 16, 16), (players[p] as AchtungPlayer).getColorTransform());
						abm.bitmapData.copyPixels((players[p] as AchtungPlayer).getBitmap().bitmapData, new Rectangle(0, 0, 16, 16), new Point((players[p] as AchtungPlayer).x - 8, (players[p] as AchtungPlayer).y - 8), null, null, true);
					}
					
					//temp.bitmapData.unlock();
					
					countDeposit++;
					if (countDeposit >= numDeposit) {
						depositing = false;
						countFree = 0;
						countDeposit = 0;
					}
					
				} else {
					countFree++;
					if (countFree >= numFree) {
						depositing = true;
						countFree = 0;
						countDeposit = 0;
					}
				}
				
				
				var c:uint = 0;
				
				for (p = 0; p < numPlayers; p++) {
					(players[p] as AchtungPlayer).boink();
					
					c = abm.bitmapData.getPixel32((players[p] as AchtungPlayer).x + 10 * Math.cos( (players[p] as AchtungPlayer).getDirection() ), (players[p] as AchtungPlayer).y + 10 * Math.sin( (players[p] as AchtungPlayer).getDirection() ));
					trace("c = " + c);
					//abm.bitmapData.setPixel((players[p] as AchtungPlayer).x, (players[p] as AchtungPlayer).y, 0xFFFF0000);
				
					//if (c != 4278190080 && c != 429490176 && c != 0) {
					if (c != 0 || (players[p] as AchtungPlayer).x < 0 || (players[p] as AchtungPlayer).y < 0 ||
								  (players[p] as AchtungPlayer).x > achtungWidth || (players[p] as AchtungPlayer).y > achtungHeight) {
						(players[p] as AchtungPlayer).setAlive(false);
						//trace((players[0] as AchtungPlayer).x + " nooooo" + c);
					}
				}
				
				//updateScoreboard();
				
				abm.bitmapData.unlock();
				
			}
		}
		
		private function KeyReleased(e:KeyboardEvent):void
		{
			//trace("code " + e.keyCode);

			switch (e.keyCode) {
				case 37 : // LEFT
					(players[0] as AchtungPlayer).keyUp(MoosesFrameworkClient.KEY_4);
					break;
				case 39 : // RIGHT
					(players[0] as AchtungPlayer).keyUp(MoosesFrameworkClient.KEY_6);
					break;
				
				case 65 : // LEFT
					(players[1] as AchtungPlayer).keyUp(MoosesFrameworkClient.KEY_4);
					break;
				case 68 : // RIGHT
					(players[1] as AchtungPlayer).keyUp(MoosesFrameworkClient.KEY_6);
					break;
			}
			
		}
		private function KeyPressed(e:KeyboardEvent):void
		{
			//trace("code " + e.keyCode);
			
			switch (e.keyCode) {
				case 37 :
					(players[0] as AchtungPlayer).keyDown(MoosesFrameworkClient.KEY_4);
					break;
				case 39 :
					(players[0] as AchtungPlayer).keyDown(MoosesFrameworkClient.KEY_6);
					break;
					
				case 65 :
					(players[1] as AchtungPlayer).keyDown(MoosesFrameworkClient.KEY_4);
					break;
				case 68 :
					(players[1] as AchtungPlayer).keyDown(MoosesFrameworkClient.KEY_6);
					break;
			}
		}
	}

}