﻿package no.ekse.achtung
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.system.fscommand;
	import flash.utils.getTimer;
	import no.ekse.mooses.MoosesConnectionEvent;
	import no.ekse.mooses.MoosesData;
	import no.ekse.mooses.MoosesFrameworkClient;
	import no.ekse.mooses.MoosesInfo;
	
	/**
	 * ...
	 * @author Magnus Ekse
	 */
	public class Main extends Sprite
	{
		private var field:AchtungWorld;
		
		private var mooses:MoosesFrameworkClient;
		private var moosesLog:MoosesInfo;
		private var moosesData:MoosesData;
		
		public static var DEBUG:Boolean = true;
		
		public function MoosesHandleConnected(e:MoosesConnectionEvent):void {
			field = new AchtungWorld(this);
			addChild(field);
		}
		public function MoosesHandleDisconnected(e:MoosesConnectionEvent):void {
			removeChild(field);
			field = null;
		}
		
		public function Main() 
		{
			
			mooses = new MoosesFrameworkClient();
			moosesLog = new MoosesInfo(mooses);
			moosesData = new MoosesData(mooses);
			
			addChild(moosesLog);
			
			moosesLog.log("Initializing");
			
			
			mooses.connect();
			
			//run in fullscreen
			fscommand("fullscreen", "true");
			
			addEventListener(Event.ENTER_FRAME, HandleEnterFrame);
			
			mooses.addEventListener(MoosesConnectionEvent.MOOSES_CONNECTED, MoosesHandleConnected);
			mooses.addEventListener(MoosesConnectionEvent.MOOSES_DISCONNECTED, MoosesHandleDisconnected);
			
			
			
			if (Main.DEBUG) {
				moosesData.addPlayer(9001, "Alpha");
				moosesData.addPlayer(9002, "Bravo");
				moosesData.addPlayer(9003, "Charlie");
				moosesData.addPlayer(9004, "Delta");
				moosesData.addPlayer(9005, "Echo");
				/*moosesData.addPlayer(9006, "Foxtrot");
				moosesData.addPlayer(9007, "Golf");
				moosesData.addPlayer(9008, "Hotel");*/
				
				field = new AchtungWorld(this);
				addChild(field);
			}
			
			addEventListener(Event.ENTER_FRAME, HandleEnterFrame);
			
		}
		
		
		public function getPlayerList():Array {
			return moosesData.getPlayerList();
		}
		
		public function sendMessage(playerId:int, message:String):void {
			
			if (mooses.connectedToFramework()) {
				
				var messageArray:Array = new Array();
				
				messageArray.push(message);
				
				mooses.sendMessageToPlayer(playerId, 20, messageArray);
				
			}
			
		}
		
		public function updateScore(playerId:int, score:int):void {
			
			if (mooses.connectedToFramework()) {
				
				mooses.updatePlayerScore(playerId, score);				
			}
			
		}
		
		private function HandleEnterFrame(e:Event):void
		{
			if (field != null) {
				field.boink();
				field.boink();
			}
		}
		
	}
	
	
	
}