﻿package no.ekse.productball 
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.geom.Point;
	import no.ekse.common.ConcreteLinkedList;
	import no.ekse.common.LinkedList;
	
	/**
	 * ...
	 * @author Magnus Ekse
	 */
	public class ProductPlayer extends Sprite
	{
		private var head:Sprite = new Sprite();
		private var radius:Number;
		
		private var velocity:Point;
		
		private var canExtraJump:Boolean;
		
		private var score:int;
		private var playerHeight:int;
		
		private var leftPlayer:Boolean;
		

		[Embed(source='res/cola.png')]
		private static const leftSprite:Class;
		
		[Embed(source='res/fanta.png')]
		private static const rightSprite:Class;
		
		private var playerSprite:Bitmap;
		
		private var offsetX:Number;
		private var offsetY:Number;
		private var unsureness:Number;
		private var originalWidth:Number;
		
		
		
		private var voters:Array = new Array();
		
		private var bar:VoteBar;
		
		public function ProductPlayer(leftPlayer:Boolean, bar:VoteBar) 
		{
			this.leftPlayer = leftPlayer;
			this.bar = bar;
			
			if (leftPlayer) {
				head.graphics.beginFill(0x800000);	
				playerSprite = new ProductPlayer.leftSprite();
			} else {
				head.graphics.beginFill(0x000080);
				playerSprite = new ProductPlayer.rightSprite();
			}
			
			radius = 50;
			head.graphics.drawCircle(0, 0, radius);
			head.alpha = 0.75;
			head.graphics.endFill();
			
			playerSprite.x = -50;
			playerSprite.y = -50;
			originalWidth = playerSprite.width;
			playerHeight = 200;
			addChild(playerSprite);
			//addChild(head);
			
			velocity = new Point();
			
			if (leftPlayer) {
				x = 100;
				y = 500;
			} else {
				x = 700
				y = 500;
			}
			
			unsureness = 0;
		}
		
		public function addVoter(voter:Voter):void
		{
			trace("voter " + voter.getVote());
			voters.push(voter);
		}
		
		public function getVoters():String
		{
			var i:int = 0;
			var s:String = "";
			
			for (i = 0; i < voters.length; i++) {
				
				s = s + (voters[i] as Voter).getName() + "\n";
			}
			
			return s;
		}
		
		private function vote():void
		{
			var numVoters:int;
			var numLeftVotes:int;
			var numRightVotes:int;
			var numJumpVotes:int;
			
			var i:int = 0;
			
			for (i = 0; i < voters.length; i++) {
				
				if ((voters[i] as Voter).getVote() == Voter.LEFT) {
					numLeftVotes++;
				} else if ((voters[i] as Voter).getVote() == Voter.RIGHT) {
					numRightVotes++;
				} else if ((voters[i] as Voter).getVote() == Voter.UP) {
					numJumpVotes++;
				}
				
				numVoters++;
			}
			
			
			if ( numJumpVotes / numVoters > 0.4 ) {
				jump();
			}
			
			move(  (numRightVotes - numLeftVotes) / numVoters);
			trace( (numRightVotes - numLeftVotes) / numVoters);
			
			
			bar.setJumpVotes(numJumpVotes);
			bar.setLeftVotes(numLeftVotes),
			bar.setRightVotes(numRightVotes);
			bar.setNumVoters(numVoters);
		}
		public function update():void 
		{
			vote();
			
			
			x += velocity.x;
			y += velocity.y;
			

			offsetX = unsureness * (Math.random() * 20 - 10);
						
			playerSprite.width = originalWidth + originalWidth * unsureness;
			playerSprite.x = offsetX - (playerSprite.width) / 2;
			
			
		}
		public function move(force:Number):void
		{
			//trace("Player move ");
			velocity.x = (force * 10);
		}
		public function jump():void
		{
			//trace("Player jump " + velocity.y);
			if (velocity.y == 0) {
				canExtraJump = true;
				velocity.y -= 20;
			}
		}
		public function extraJump(force:Number):void
		{
			if (canExtraJump) {
				canExtraJump = false;
				velocity.y -= force * 10;
			}
		}
		
		public function getRadius():Number
		{
			return radius;
		}
		
		public function getVelocity():Point
		{
			return velocity;
		}
		
		public function getPlayerHeight():int
		{
			return playerHeight;
		}
		public function getCanExtraJump():Boolean
		{
			return canExtraJump;
		}
		
		public function getScore():int
		{
			return score;
		}
		public function setScore(newScore:int):void
		{
			score = newScore;
		}
		public function addScore(newScore:int):void
		{
			score += newScore;
		}
	}
	
}