﻿package  no.ekse.mooses
{
	
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.getTimer;
	
	public class MoosesInfo extends Sprite
	{
		private var textLog:TextField = new TextField();
		private var client:MoosesFrameworkClient;
		
		public function MoosesInfo(client:MoosesFrameworkClient) {
			this.client = client;
			textLog.autoSize = "left";
			
			log("Flash for MOOSES\n");
			
			client.addEventListener(MoosesConnectionEvent.MOOSES_ATTEMPTCONNECT, moosesAttemptConnect);
			client.addEventListener(MoosesConnectionEvent.MOOSES_ERRORCONNECT, moosesConnectionError);
			client.addEventListener(MoosesConnectionEvent.MOOSES_CONNECTED, moosesConnected);
			client.addEventListener(MoosesConnectionEvent.MOOSES_DISCONNECTED, moosesDisconnected);
			client.addEventListener(MoosesPlayerEvent.MOOSES_PLAYER_JOIN, moosesPlayerJoin);
			client.addEventListener(MoosesPlayerEvent.MOOSES_PLAYER_QUIT, moosesPlayerQuit);
			client.addEventListener(MoosesKeyEvent.MOOSES_KEY_EVENT, moosesKey);
			
			addChild(textLog);
		}
		
		public function log(s:String):void {
			textLog.appendText("\n" + s);
			trace("MoosesLog: " + s);
		}
		public function moosesKey(e:MoosesKeyEvent):void {
			log("Key event: key [" + e.keyCode + "] state [" + e.keyState + "] player id [" + e.playerId + "]");
		}
		public function moosesPlayerJoin(e:MoosesPlayerEvent):void {
			log("Player connected: " + e.playerName + ":" + e.playerId);
		}
		public function moosesPlayerQuit(e:MoosesPlayerEvent):void {
			log("Player disconnected: " + e.playerName + ":" + e.playerId);
		}
		public function moosesAttemptConnect(e:MoosesConnectionEvent):void {
			log("Attempting to connect to framework");
		}
		public function moosesConnected(e:MoosesConnectionEvent):void {
			log("Connected to framework");
		}
		public function moosesDisconnected(e:MoosesConnectionEvent):void {
			log("Disconnected from framework");
		}
		public function moosesConnectionError(e:MoosesConnectionEvent):void {
			log("Connection error");
		}
		
	}
}