﻿package  no.ekse.elk
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.utils.getTimer;
	import no.ekse.common.LinkedListNode;

	/**
	 * ...
	 * @author Magnus Ekse
	 */
	public class Bullet extends Sprite implements LinkedListNode
	{
		[Embed(source='res/bullet.png')]
		private static const GfxBullet:Class;
		
		private var alive:Boolean = true;
		private var velocity:Point = new Point(0, 0);
		private var damage:int = 40;
		private var gfx:Bitmap;
		
		private var outOfRange:Boolean = false;
		private var maxUpdates:int = 100;
		private var numUpdates:int = 0;
		
		private var _prevNode:LinkedListNode;
		private var _nextNode:LinkedListNode;
		
		public function Bullet() 
		{
			gfx = new Bullet.GfxBullet();
			gfx.x = -9;
			gfx.y = -9;
			
			
			addChild(gfx);
			
		}
		public function SetVelocity(velocity:Point):void {
			this.velocity = velocity;
		}
		public function SetMaxUpdates(n:int):void {
			this.maxUpdates = n;
		}
		public function IsAlive():Boolean {
			return alive;
		}
		public function GetDamage():int {
			return damage;
		}
		public function Die():void {
			if (alive) {
				alive = false;
				damage = 0;
				removeChild(gfx);
			}
		}
		public function Update():void {
			this.x += velocity.x;
			this.y += velocity.y;
			numUpdates++;
			
			rotation += 30;
			
			if (numUpdates >= maxUpdates || x < 5 * 64) {
				Die();
			}
		}
		
		
		public function get previousNode():LinkedListNode {
			return _prevNode;
		}
		public function set previousNode(value:LinkedListNode):void {
			_prevNode = value;
		}
		
		public function get nextNode():LinkedListNode {
			return _nextNode;
		}
		public function set nextNode(value:LinkedListNode):void{
			_nextNode = value;
		}
		
		public function equals(o:Object):Boolean{
			return o === this;
		}
	}
	
}
