﻿package  no.ekse.elk
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.getTimer;
	import no.ekse.common.ConcreteLinkedList;
	import no.ekse.common.LinkedList;
	import no.ekse.common.LinkedListNode;
	import no.ekse.elk.buff.IBuff;
	import no.ekse.mooses.MoosesPlayer;
	import no.ekse.mooses.MoosesUnit;
	import no.ekse.mooses.MoosesFrameworkClient;
	import no.ekse.elk.buff.IBuffable;
	
	/**
	 * ...
	 * @author Magnus Ekse
	 */
	public class Defender extends Sprite implements MoosesUnit, IBuffable
	{
		[Embed(source='res/pillbox.png')]
		private static const GfxDefender:Class;
		
		[Embed(source='res/turret.png')]
		private static const GfxTurret:Class;
		
		private var sourceTurret:Bitmap;
		private var targetTurret:Bitmap;
		private var contTurret:Sprite;
		
		private var world:World = null;
		private var player:MoosesPlayer = null;
		
		private var lastShot:Number = 0;
		private var haste:Number = 0;
		
		private var buffs:LinkedList = new ConcreteLinkedList();
		
		private var rangeCircle:Sprite = new Sprite();
		private var rangeCircleShown:Boolean = false;

		private var direction:int = 4;
		private var rotationSpeed:Number = 0;
		public function Defender(world:World, player:MoosesPlayer) 
		{
			
			var plate:Nameplate = new Nameplate(true);
			plate.SetName(player.getPlayerName());
			plate.SetHealth(100);
			/*
			gfx = new Defender.GfxDefender();
			gfx.x = 0;
			gfx.y = 0;
			*/
			var turretBD:BitmapData = new BitmapData(64, 64, true);
			sourceTurret = new GfxTurret();
			targetTurret = new Bitmap(turretBD);
			contTurret = new Sprite();
			
			
			RenderDefender(5);
			
			x = (Math.floor(Math.random() * 15) + 12) * 64;
			y = (Math.floor(Math.random() * 10 + 3)) * 64;
			
			rangeCircle.graphics.beginFill(0xE0E0FF);
			rangeCircle.graphics.drawCircle(32, 32, 540);
			rangeCircle.alpha = 0.1;
			rangeCircleShown = false;
			rangeCircle.graphics.endFill();
			
			addChild(rangeCircle);
			
			targetTurret.x = -32;
			targetTurret.y = -32;
			contTurret.addChild(targetTurret);
			contTurret.x = 32;
			contTurret.y = 32;
			
			addChild(contTurret);
			addChild(plate);
			
			this.player = player;
			this.world = world;
			
			
		}
		
		public function AddBuff(buff:LinkedListNode):void {
			buffs.insertAtEnd(buff);
		}
		
		public function AddHaste(value:Number):void {
			haste += value;
		}
		
		public function RemoveHaste(value:Number):void {
			haste -= value;
		}
		public function getMoosesPlayer():MoosesPlayer {
				return player;
		}
		public function setMoosesPlayer(player:MoosesPlayer):void {
			
			this.player = player;
		}
		public function Update():void {

			if (world.GetGameState() == World.GS_DEPLOY && !rangeCircleShown) {
				rangeCircleShown = true;
				rangeCircle.alpha = 0.5;
			}
			if (world.GetGameState() == World.GS_RUNNING && rangeCircleShown) {
				rangeCircleShown = false;
				rangeCircle.alpha = 0.2;
			}


			contTurret.rotation += rotationSpeed;

			
			if (Main.DEBUG && player.getPlayerId() > 9000) {
				
				if (Math.random() > 0.5) {
					keyDown(MoosesFrameworkClient.KEY_4);
				} else {
					keyDown(MoosesFrameworkClient.KEY_6);
				}
				Shoot(1 + (Math.floor(Math.random() * 9)));
			}
			
		}
		
		private function RenderDefender(directionz:int):void {
			targetTurret.bitmapData = new BitmapData(64, 64, true);
			targetTurret.bitmapData.lock();
			
			targetTurret.bitmapData.copyPixels(sourceTurret.bitmapData, new Rectangle(64, 0, 64, 64), new Point(0, 0));
			/*
			if (direction == 1) {
				targetTurret.bitmapData.copyPixels(sourceTurret.bitmapData, new Rectangle(0, 0, 64, 64), new Point(0, 0));
			} else if (direction == 2) {
				targetTurret.bitmapData.copyPixels(sourceTurret.bitmapData, new Rectangle(64, 0, 64, 64), new Point(0, 0));
			} else if (direction == 3) {
				targetTurret.bitmapData.copyPixels(sourceTurret.bitmapData, new Rectangle(128, 0, 64, 64), new Point(0, 0));
			} else if (direction == 4) {
				targetTurret.bitmapData.copyPixels(sourceTurret.bitmapData, new Rectangle(0, 64, 64, 64), new Point(0, 0));
			} else if (direction == 5) {
				targetTurret.bitmapData.copyPixels(sourceTurret.bitmapData, new Rectangle(0, 64, 64, 64), new Point(0, 0));
			} else if (direction == 6) {
				targetTurret.bitmapData.copyPixels(sourceTurret.bitmapData, new Rectangle(128, 64, 64, 64), new Point(0, 0));
			} else if (direction == 7) {
				targetTurret.bitmapData.copyPixels(sourceTurret.bitmapData, new Rectangle(0, 128, 64, 64), new Point(0, 0));
			} else if (direction == 8) {
				targetTurret.bitmapData.copyPixels(sourceTurret.bitmapData, new Rectangle(64, 128, 64, 64), new Point(0, 0));
			} else if (direction == 9) {
				targetTurret.bitmapData.copyPixels(sourceTurret.bitmapData, new Rectangle(128, 128, 64, 64), new Point(0, 0));
			}
			*/
			targetTurret.bitmapData.unlock();
		}
		
		public function Shoot(directionz:int):void {
			
			if (world.GetGameState() != World.GS_RUNNING) { return; }
			
			if (lastShot > getTimer() - 1000 * (1 - haste  * 8)) { return; }
			
			var newBullet:Bullet = new Bullet();
			newBullet.x = this.x + 32;
			newBullet.y = this.y + 32;
			
			var velocity:Point = new Point(Math.cos( 2 * Math.PI * (contTurret.rotation/360) - Math.PI / 2), Math.sin(2 * Math.PI * (contTurret.rotation/360) - Math.PI / 2));
			/*
			if (direction == 1 || direction == 4 || direction == 7) {
				velocity.x  = -1;
			}
			if (direction == 3 || direction == 6 || direction == 9) {
				velocity.x  = 1;
			}
			if (direction == 1 || direction == 2 || direction == 3) {
				velocity.y  = -1;
			}
			if (direction == 7 || direction == 8 || direction == 9) {
				velocity.y  = 1;
			}
			*/
			RenderDefender(direction);
			
			velocity.normalize(12);
			/*
			velocity.x = velocity.x * 8;
			velocity.y = velocity.y * 8;
			*/
			newBullet.SetVelocity(velocity);
			newBullet.SetMaxUpdates(45);

			world.SpawnBullet(newBullet);
			
			lastShot = getTimer();
		}
		
		/*  a   b	|  12    13
		 *  1 2 3	|  01 02 03
		 *  4 5 6	|  04 05 06
		 *  7 8 9	|  07 08 09
		 *  * 0 #	|  10 00 11
		 */	
		public function keyUp(keyId:int):void {
			
			if (world.GetGameState() == World.GS_RUNNING) {
				if (keyId == MoosesFrameworkClient.KEY_4) {
					rotationSpeed = 0;
				} else if (keyId == MoosesFrameworkClient.KEY_6) {
					rotationSpeed = 0;
				}
			}
			
		}
		public function keyDown(keyId:int):void {
			if (world.GetGameState() == World.GS_DEPLOY) {
				
				if (keyId == MoosesFrameworkClient.KEY_4) {
					x -= 64;
				} else if (keyId == MoosesFrameworkClient.KEY_6) {
					x += 64;
				} else if (keyId == MoosesFrameworkClient.KEY_2) {
					y -= 64;
				} else if (keyId == MoosesFrameworkClient.KEY_8) {
					y += 64;
				} else if (keyId == MoosesFrameworkClient.KEY_1) {
					x -= 64;
					y -= 64;
				} else if (keyId == MoosesFrameworkClient.KEY_3) {
					x += 64;
					y -= 64;
				} else if (keyId == MoosesFrameworkClient.KEY_7) {
					x -= 64;
					y += 64;
				} else if (keyId == MoosesFrameworkClient.KEY_9) {
					x += 64;
					y += 64;
				}
				if (x < 5 * 64) { x = 5 * 64; }
				if (x > 23 * 64) { x = 23 * 64; }
				if (y < 2 * 64) { y = 2 * 64; }
				if (y > 15 * 64) { y = 15 * 64; }
				
			}
			
			if (world.GetGameState() == World.GS_RUNNING) {
				
				if (keyId == MoosesFrameworkClient.KEY_4) {
					//Shoot(4);
					/*
					switch (direction)
					{
						case 1:
							direction = 4; break;
						case 2:
							direction = 1; break;
						case 3:
							direction = 2; break;
						case 4:
							direction = 7; break;
						case 6:
							direction = 3; break;
						case 7:
							direction = 8; break;
						case 8:
							direction = 9; break;
						case 9:
							direction = 6; break;
						default:
							trace ("uuu")
					}
					
					RenderDefender(direction);
			
					*/
			
					
					rotationSpeed = -5;
				} else if (keyId == MoosesFrameworkClient.KEY_6) {
					//Shoot(6);
					/*
					switch (direction)
					{
						case 1:
							direction = 2; break;
						case 2:
							direction = 3; break;
						case 3:
							direction = 6; break;
						case 4:
							direction = 1; break;
						case 6:
							direction = 9; break;
						case 7:
							direction = 4; break;
						case 8:
							direction = 7; break;
						case 9:
							direction = 8; break;
						default:
							trace ("ooo")
					}
					
					RenderDefender(direction);
					*/
					rotationSpeed = 5;
			
				} else if (keyId == MoosesFrameworkClient.KEY_2) {
					Shoot(2);
				} else if (keyId == MoosesFrameworkClient.KEY_8) {
					Shoot(8);
				} else if (keyId == MoosesFrameworkClient.KEY_1) {
					Shoot(1);
				} else if (keyId == MoosesFrameworkClient.KEY_3) {
					Shoot(3);
				} else if (keyId == MoosesFrameworkClient.KEY_7) {
					Shoot(7);
				} else if (keyId == MoosesFrameworkClient.KEY_9) {
					Shoot(9);
				}
				
				if (direction < 1) {
					direction += 9;
				}
				if (direction > 9) {
					direction -= 9;
				}
				
				trace("up dir " + direction);
				
			}
		}
		
	}
	
}
