﻿package no.ekse.elk
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.utils.Timer;
	import no.ekse.mooses.MoosesUnit;
	
	import flash.utils.getTimer;
	
	
	import no.ekse.mooses.MoosesConnectionEvent;
	import no.ekse.mooses.MoosesData;
	import no.ekse.mooses.MoosesFrameworkClient;
	import no.ekse.mooses.MoosesInfo;
	
	import flash.system.fscommand;

	public class Main extends Sprite
	{
		
		private var world:World;
		
		private var lastUpdate:Number = 0;
		private var timeSpentInLoop:Number = 0;
		private var t:Number = 0;
		
		private var mooses:MoosesFrameworkClient;
		private var moosesLog:MoosesInfo;
		private var moosesData:MoosesData;
		
		public static var DEBUG:Boolean = false;
		
		public function MoosesHandleConnected(e:MoosesConnectionEvent):void {
			world = new World(this);
			addChild(world);
		}
		public function MoosesHandleDisconnected(e:MoosesConnectionEvent):void {
			removeChild(world);
			world = null;
			fscommand("quit");
		}
		
		
		public function Main():void 
		{
			mooses = new MoosesFrameworkClient();
			moosesLog = new MoosesInfo(mooses);
			moosesData = new MoosesData(mooses);
			
			addChild(moosesLog);
			
			moosesLog.log("Initializing");
			
			mooses.connect();
			
			//run in fullscreen
			fscommand("fullscreen", "true");
			
			addEventListener(Event.ENTER_FRAME, HandleEnterFrame);
			
			mooses.addEventListener(MoosesConnectionEvent.MOOSES_CONNECTED, MoosesHandleConnected);
			mooses.addEventListener(MoosesConnectionEvent.MOOSES_DISCONNECTED, MoosesHandleDisconnected);
			
			if (Main.DEBUG) {
				moosesData.addPlayer(9001, "Alpha");
				moosesData.addPlayer(9002, "Bravo");
				
				moosesData.addPlayer(9004, "Charlie");
				moosesData.addPlayer(9005, "Delta");
				moosesData.addPlayer(9006, "Echo");
				moosesData.addPlayer(9007, "Foxtrot");
				/*
				moosesData.addPlayer(7, "Golf");
				moosesData.addPlayer(8, "Hotel");
				moosesData.addPlayer(9, "India");
				moosesData.addPlayer(10, "Juliett");
				moosesData.addPlayer(11, "Kilo");
				moosesData.addPlayer(12, "Lima");
				/*
				moosesData.AddPlayer(13, "Mike");
				moosesData.AddPlayer(14, "November");
				moosesData.AddPlayer(15, "Oscar");
				
				moosesData.AddPlayer(16, "Quebec");
				moosesData.AddPlayer(17, "Romeo");
				moosesData.AddPlayer(18, "Sierra");
				
				moosesData.AddPlayer(19, "Tango");
				moosesData.AddPlayer(20, "Uniform");
				moosesData.AddPlayer(21, "Victor");
				*/
				world = new World(this);
				addChild(world);
			
			}
			//fscommand("quit");
			
		}
		
		public function GetPlayerList():Array {
			return moosesData.getPlayerList();
		}
		
		public function BuzzUnit(unit:MoosesUnit, duration:int):void {
			moosesData.buzzUnit(unit, duration);
		}
		
		private function HandleEnterFrame(e:Event):void {
			if (world != null) {
				
				if (lastUpdate < getTimer()) {
					lastUpdate = getTimer() + 1000;
					//trace("loop tid: " + timeSpentInLoop + " est fps " + (1 / (timeSpentInLoop / 1000)) );
					timeSpentInLoop = 0;
				}
				t = getTimer();
				
				world.Update();
				
				timeSpentInLoop += (getTimer() - t);
			}
		}
		
	}
	
}