﻿package no.ekse.elk 
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import no.ekse.common.LinkedListNode;
	
	/**
	 * ...
	 * @author Magnus Ekse
	 */
	public class Particle extends Sprite implements LinkedListNode
	{
		
		[Embed(source='res/ministar.png')]
		private static const GfxParticle:Class;
		
		private var angularVelocity:Number = 0.0;
		private var velocityX:Number;
		private var velocityY:Number;
		private var ttl:int;
		private var initialTtl:int;
		
		private var _prevNode:LinkedListNode;
		private var _nextNode:LinkedListNode;
		
		public function Particle(x:Number, y:Number, vx:Number, vy:Number, av:Number, ttl:int) 
		{
			this.x = x;
			this.y = y;
			this.velocityX = vx;
			this.velocityY = vy;
			this.ttl = ttl;
			initialTtl = ttl;
			
			var gfx:Bitmap = new Particle.GfxParticle();
			gfx.x = -8;
			gfx.y = -8;
			
			addChild(gfx);
		}
		
		public function Update():void {
			x += velocityX;
			y += velocityY;
			rotation += angularVelocity;
			ttl--;
			alpha = ttl / initialTtl;
		}
		
		public function IsDead():Boolean {
			return ttl <= 0;
		}
		
		
		
		
		public function get previousNode():LinkedListNode {
			return _prevNode;
		}
		public function set previousNode(value:LinkedListNode):void {
			_prevNode = value;
		}
		
		public function get nextNode():LinkedListNode {
			return _nextNode;
		}
		public function set nextNode(value:LinkedListNode):void{
			_nextNode = value;
		}
		
		public function equals(o:Object):Boolean{
			return o === this;
		}
	}
	
}