﻿package  no.ekse.elk
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	
	/**
	 * ...
	 * @author Magnus Ekse
	 */
	public class Tile extends Sprite
	{
		public static const GRASS:int = 0;
		public static const TREE:int = 1;
		public static const CONCRETE:int = 2;
		public static const RIVER_DOWN:int = 3;
		public static const HORISONTAL_BRIDGE:int = 4;

		[Embed(source='res/grass.png')]
		public static const GfxGrass:Class;
		
		[Embed(source='res/tree_tile.png')]
		public static const GfxTree:Class;
		
		[Embed(source='res/concrete.png')]
		public static const GfxConcrete:Class;
		
		[Embed(source='res/river_down.png')]
		public static const GfxRiverDown:Class;
		
		[Embed(source='res/bridge_hori.png')]
		public static const GfxHorisontalBridge:Class;
		
		[Embed(source='res/tiles.png')]
		public static const GfxTiles:Class;
		
		private var gfx:Bitmap;
		private var traversable:Boolean = true;
		private var blocking:Boolean = false;
		private var gfxAdded:Boolean = false;
		private var tileType:int = GRASS;
		
		public function Tile(tileType:int) 
		{
			SetTile(tileType);
		}
		public function GetTileType():int {
			return tileType;
		}
		public function SetTile(tileType:int):void {
			
			if (gfxAdded) { removeChild(gfx); }
			
			if (tileType == Tile.GRASS) {
				gfx = new Tile.GfxGrass();
				traversable = true;
				blocking = false;
			}
			if (tileType == Tile.TREE) {
				gfx = new Tile.GfxTree();
				traversable = false;
				blocking = true;
			}
			if (tileType == Tile.CONCRETE) {
				gfx = new Tile.GfxConcrete();
				traversable = false;
				blocking = false;
			}
			if (tileType == Tile.RIVER_DOWN) {
				gfx = new Tile.GfxRiverDown();
				traversable = false;
				blocking = false;
			}
			if (tileType == Tile.HORISONTAL_BRIDGE) {
				gfx = new Tile.GfxHorisontalBridge();
				traversable = true;
				blocking = false;
			}
			
			this.tileType = tileType;
			addChild(gfx);
			gfxAdded = true;
		}
		
		public function IsTraversable():Boolean {
			return traversable;
		}
		public function IsBlocking():Boolean {
			return blocking;
		}
		
		
	}
	
}