﻿package  no.ekse.elk
{
	
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.SpreadMethod;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.getTimer;
	import no.ekse.common.ConcreteLinkedList;
	import no.ekse.common.LinkedList;
	import no.ekse.elk.buff.HasteBuff;
	import no.ekse.elk.mapobject.Haste;
	import no.ekse.elk.mapobject.IMapObject;
	import no.ekse.elk.mapobject.Scorefield;
	import no.ekse.mooses.MoosesPlayer;
	import flash.system.fscommand;

	public class World extends Sprite
	{
		public static var GS_LIMBO:int = 0;
		public static var GS_DEPLOY:int = 1;
		public static var GS_RUNNING:int = 2;
		public static var GS_OVER:int = 3;
		
		public static var WIDTH:int = 1920;
		public static var HEIGHT:int = 1080;
		
		
		private var loopTime:Array = new Array(10);
		private var lastUpdate:Number = 0;
		private var t:Number = 0;
		
		
		private var maximumRespawns:int = 100;
		private var currentRespawns:int = 0;
		
		private var maximumPoints:int = 100;
		private var currentPoints:int = 0;
		
		private var main:Main;
		
		private var largeText:TextFormat = new TextFormat();
		private var leftText:TextField = new TextField();
		private var centerText:TextField = new TextField();
		private var rightText:TextField = new TextField();
		
		[Embed(source='res/scoreboard.png')]
		private static const GfxScoreboard:Class;
		private var scoreboard:Bitmap;
		private var timerbar:Sprite;
		
		[Embed(source='res/scoreboardc.png')]
		private static const GfxScoreboardCenter:Class;
		private var scoreboardcenter:Bitmap;
		
		private var unavailableDeployArea:Sprite = new Sprite();
		
		
		
		
		private var gameState:int = GS_LIMBO;
		private var nextGameState:int = GS_DEPLOY;
		private var timeToChangeGameState:Number = 1;
		private var timeForPrevGameStateChange:Number = 1;
		
		private var attackers:LinkedList = new ConcreteLinkedList();
		private var defenders:Array = new Array();
		private var bullets:LinkedList = new ConcreteLinkedList();
		
		private var terrainBackgroundData:BitmapData;
		private var terrainBackground:Bitmap;
		
		private var traversableGrid:Array = new Array(30 * 17);
		private var mapObjectGrid:Array = new Array(30 * 17);
		
		private var particles:LinkedList = new ConcreteLinkedList;
		
		private var numFrames:int = 0;
		private var lastCheck:Number = 0;
		private var fpsMon:TextField = new TextField();
		
		private var roundsFinished:int = 0;
		
		private var tss:Sprite;
		
		public function World(main:Main) {
			this.main = main;
			
			scoreboard = new World.GfxScoreboard();
			scoreboardcenter = new World.GfxScoreboardCenter();
			
			timerbar = new Sprite();
			timerbar.graphics.beginFill(0x0000FF);
			timerbar.graphics.drawRect(5, 130, 380, 15);
			timerbar.graphics.endFill();
			
			fpsMon.text = "?? FPS";
			fpsMon.x = 200;
			fpsMon.y = 100;
			lastCheck = getTimer();
			
			
			
			largeText.color = 0x000000;
			largeText.size = 36;
			largeText.bold = true;
			

			leftText.text = "Left Textfield";
			leftText.autoSize = "left";
			leftText.y = 20;
			leftText.x = 20;
			leftText.width = 400;
			leftText.height = 40;
			leftText.background = false;
			leftText.backgroundColor = 0x000000;
			leftText.mouseEnabled = false;
			leftText.selectable = false;
			leftText.setTextFormat(largeText);
			
			
			centerText.text = "Center Textfield";
			centerText.autoSize = "left";
			centerText.y = 10;
			centerText.x = 760;
			centerText.width = 400;
			centerText.height = 40;
			centerText.background = false;
			centerText.backgroundColor = 0x000000;
			centerText.mouseEnabled = false;
			centerText.selectable = false;
			centerText.setTextFormat(largeText);
			
			scoreboardcenter.x = 730;
			
			rightText.text = "Right Textfield";
			rightText.autoSize = "left";
			rightText.y = 60;
			rightText.x = 20;
			rightText.width = 400;
			rightText.height = 40;
			rightText.background = false;
			rightText.backgroundColor = 0x000000;
			rightText.mouseEnabled = false;
			rightText.selectable = false;
			rightText.setTextFormat(largeText);
			
			
			unavailableDeployArea.graphics.beginFill(0xFF5050);
			unavailableDeployArea.alpha = 0.2;
			unavailableDeployArea.graphics.drawRect(0, 0, 5 * 64, 17 * 64);
			unavailableDeployArea.graphics.drawRect(23 * 64, 0, 5 * 64, 17 * 64);
			unavailableDeployArea.graphics.drawRect(5 * 64, 0, 20 * 64, 2 * 64);
			unavailableDeployArea.graphics.drawRect(5 * 64, 15 * 64, 20 * 64, 2 * 64);
			unavailableDeployArea.graphics.endFill();
			
			gameState = GS_LIMBO;
			nextGameState = GS_DEPLOY;
			timeForPrevGameStateChange = getTimer();
			timeToChangeGameState = getTimer() + 4000;
			//BeginRunning();
			
			loopTime[0] = 0.0; loopTime[1] = 0.0; loopTime[2] = 0.0;
			loopTime[3] = 0.0; loopTime[4] = 0.0; loopTime[5] = 0.0;
			loopTime[6] = 0.0; loopTime[7] = 0.0; loopTime[8] = 0.0;
			loopTime[9] = 0.0;
		}
		
		public function particleExplosion(x:Number, y:Number):void {
			for (var z:Number = 0; z < 2 * Math.PI; z += (Math.PI / 10)) {
				var v:Number = 1 + 2 * Math.random();
				var newP:Particle = new Particle(x, y, Math.cos(z) * v, Math.sin(z) * v, 0.1, 120);
				addChild(newP);
				particles.insertAtEnd(newP);
				//trace("new particle " + z);
			}
		}
		
		public function SpawnBullet(bullet:Bullet):void {
			
			bullets.insertAtEnd(bullet);
			addChild(bullet);
			
		}
		public function IsTraversable(x:Number, y:Number):Boolean {
			var isTraversable:Boolean = true;
			var gridX:int = uint(x / 64);
			var gridY:int = uint(y / 64);
				
			if (gridX >= 0 && gridX <= World.WIDTH / 64 && gridY >= 0 && gridY <= World.HEIGHT / 64 ) {
				isTraversable = isTraversable && (traversableGrid[gridX + gridY * 30] as Tile).IsTraversable();
				
			} else {
				isTraversable = false;
			}
			return isTraversable;
		}
		public function IsBlocking(x:Number, y:Number):Boolean {
			var isBlocking:Boolean = false;
			var gridX:int = uint(x / 64);
			var gridY:int = uint(y / 64);
				
			if (gridX >= 0 && gridX <= World.WIDTH / 64 && gridY >= 0 && gridY <= World.HEIGHT / 64 ) {
				isBlocking = isBlocking && (traversableGrid[gridX + gridY * 30] as Tile).IsBlocking();
				
			} else {
				isBlocking = false;
			}
			return isBlocking;
		}
		
		public function IsTree(x:int, y:int):Boolean {
			if (traversableGrid[x + y * 30] == undefined) {
				return true;
			}
			if (traversableGrid[x + y * 30] == null) {
				return true;
			}
			
			if ((traversableGrid[x + y * 30] as Tile).GetTileType() == Tile.TREE) {
				return true;
			}
			
			return false;
		}

		public function RenderBackground():void {
			
			var tiles:Bitmap = new Tile.GfxTiles();
			
			terrainBackgroundData = new BitmapData(1920, 1080, false, 0x0);
			
			
			
			terrainBackgroundData.lock();
			for (var y:int = 0; y < 17; y++) {
				for (var x:int = 0; x < 30; x++) {
					
					switch( (traversableGrid[x + y * 30] as Tile).GetTileType() ) {
						
						case Tile.TREE:
							terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(0, 0, 64, 64), new Point(x * 64, y * 64));
							
							
							if (IsTree(x - 1, y) && IsTree(x, y - 1) && IsTree(x - 1, y - 1) == false) {
								terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(64 * 3, 64 * 4, 64, 64), new Point(x * 64, y * 64));
							}
							if (IsTree(x, y - 1) && IsTree(x + 1, y) && IsTree(x + 1, y - 1) == false) {
								terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(64 * 0, 64 * 3, 64, 64), new Point(x * 64, y * 64));
							}
							if (IsTree(x, y + 1) && IsTree(x - 1, y) && IsTree(x - 1, y + 1) == false) {
								terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(64 * 3, 64 * 0, 64, 64), new Point(x * 64, y * 64));
							}
							
							if (IsTree(x, y + 1) == false && IsTree(x + 1, y) == false && IsTree(x + 1, y + 1) == false) {
								terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(64 * 1, 64 * 1, 64, 64), new Point(x * 64, y * 64));
							}
							
							if (IsTree(x, y - 1) == false && IsTree(x + 1, y) == false && IsTree(x + 1, y - 1) == false) {
								terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(64 * 1, 64 * 3, 64, 64), new Point(x * 64, y * 64));
							}
							
							if (IsTree(x - 1, y) == false && IsTree(x, y - 1) == false && IsTree(x - 1, y - 1) == false) {
								terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(64 * 3, 64 * 3, 64, 64), new Point(x * 64, y * 64));
							}
							if (IsTree(x - 1, y + 1) == false && IsTree(x, y + 1) == false && IsTree(x - 1, y) == false) {
								terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(64 * 3, 64 * 1, 64, 64), new Point(x * 64, y * 64));
							}
							
							if (IsTree(x - 1, y) && IsTree(x + 1, y - 1) && IsTree(x, y + 1) == false) {
								terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(64 * 2, 64 * 0, 64, 64), new Point(x * 64, y * 64));
							}
							if (IsTree(x - 1, y) && IsTree(x + 1, y) && IsTree(x, y - 1) == false) {
								terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(64 * 2, 64 * 4, 64, 64), new Point(x * 64, y * 64));
							}
							
							if (IsTree(x, y - 1) && IsTree(x, y + 1) && IsTree(x + 1, y) == false) {
								terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(64 * 0, 64 * 2, 64, 64), new Point(x * 64, y * 64));
							}
							if (IsTree(x, y - 1) && IsTree(x, y + 1) && IsTree(x - 1, y) == false) {
								terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(64 * 4, 64 * 2, 64, 64), new Point(x * 64, y * 64));
							}
							
							break;
							
						case Tile.GRASS:
							terrainBackgroundData.copyPixels(tiles.bitmapData, new Rectangle(128, 128, 64, 64), new Point(x * 64, y * 64));
							break;
						
					}
					
				}
			}
			
			terrainBackgroundData.unlock();
			
			terrainBackground = new Bitmap(terrainBackgroundData);
			
			addChild(terrainBackground);
		}
		
		
		public function BeginDeploy():void {
			
			if (main.GetPlayerList().length < 2) {
				timeForPrevGameStateChange = getTimer();
				timeToChangeGameState = getTimer() + 30 * 1000;
				centerText.text = "Too few players, need at least two.";
				trace("Only " + main.GetPlayerList().length + " players connected, too few!");
				fscommand("quit");
				return;
			} else {
				trace(main.GetPlayerList().length + " players connected, going for it!");
				
			}
			
			if (roundsFinished > 0) {
				fscommand("quit");
				
			}
			
			
			trace("STATE IS NOW GAME DEPLOY");
			
			//Remove all display objects (resetting the board)
			var toRemove:Array = new Array();
			var i:int;
			
			for(i=0; i < this.numChildren; i++)
			{
				var mc:DisplayObject = this.getChildAt(i);
				toRemove.push(mc);
			}
			for each(var t:DisplayObject in toRemove) {
				removeChild(t);
			}
			
			//Adding the map
			//var map:String     = "tttttttttttttttttttttttttttttttttttt                       tttttt                        tt        ttt       tt        tt         ttt      ttt       tt                   t        tt                            tt            tt              tt           tttt             tt            ttt             tt                            tt                  tt        tt        ttt       ttttt     tt      tttttt        ttt     tt         tttt               tt                            ttttttttttttttttttttttttttttttt";
			var map:String     = "ttttttttttttttttttttttttttttttttttttttttttttttttttttttttttttt                            tt                            tt        tt                  tt       tttt       tt        tt       tttt      ttttt      tt                 ttttt      tt                            tt       tttttt               tt       tttttt     ttt       tt                  tttt      tt                  tttt      tt         tttt               tt        ttttt               tt        tttttttttttttttt    ttttttttttttttttttttttttttttttt";
			//var objects:String = "                                                                     h                                      h                                                              h                     h                                            s                             s                 h           s                                          h      h                                               h                                      h                                                                          ";
			var objects:String = "                                                                                        s           h                 s                     h       s                                                                                                      h                s                      h      s                                                                        h                                        h     s                             s                             s                               ";
			
			for (var y:int = 0; y < 17; y++) {
				for (var x:int = 0; x < 30; x++) {
					var m:String = map.charAt(x + y * 30);
					
					
					if (m == "t") {
						traversableGrid[x + y * 30] = new Tile(Tile.TREE);
					} else if (m == "r") {
						traversableGrid[x + y * 30] = new Tile(Tile.RIVER_DOWN);
					} else if (m == "b") {
						traversableGrid[x + y * 30] = new Tile(Tile.HORISONTAL_BRIDGE);
					} else {
						traversableGrid[x + y * 30] = new Tile(Tile.GRASS);
					}
					
					(traversableGrid[x + y * 30] as Tile).x = x * 64;
					(traversableGrid[x + y * 30] as Tile).y = y * 64;
					//addChild(traversableGrid[x + y * 30]);
					
					
				}
			}
			
			RenderBackground();
			
			for (y = 0; y < 17; y++) {
				for (x = 0; x < 30; x++) {
					
					var o:String = objects.charAt(x + y * 30);
					
					if (o == "s") {
						mapObjectGrid[x + y * 30] = new Scorefield();
					} else if (o == "h") {
						mapObjectGrid[x + y * 30] = new Haste();
					} else {
						mapObjectGrid[i] = null;
					}
					
					if (mapObjectGrid[x + y * 30] != null) {
						(mapObjectGrid[x + y * 30] as Sprite).x = x * 64;
						(mapObjectGrid[x + y * 30] as Sprite).y = y * 64;
						addChild(mapObjectGrid[x + y * 30] as Sprite);
					}
				}
			}
			
			addChild(fpsMon);
			
			addChild(unavailableDeployArea);
			
			addChild(scoreboard);
			addChild(leftText);
			
			addChild(scoreboardcenter);
			addChild(centerText);
			
			addChild(rightText);
			addChild(timerbar);
			
			
			
			
			
			
			
			i = 0;
			
			
			//Clear old attacker/defender arrays
			attackers = new ConcreteLinkedList();
			defenders = new Array();
			
			//remove concrete below defenders
			for (var n:int = 0; n < traversableGrid.length; n++) {
				if ((traversableGrid[n] as Tile).GetTileType() == Tile.CONCRETE) {
					(traversableGrid[n] as Tile).SetTile(Tile.GRASS);
				}
			}	
			
			var players:Array = main.GetPlayerList();
			var playerCount:int = 0;
			var possibleDefenders:Array = new Array();
			
			//Remove old attachments and count actual players
			for (i = 0; i < players.length; i++) {
				(players[i] as MoosesPlayer).detachUnit();
				
				if ((players[i] as MoosesPlayer).getPlayerId() >= 0) {
					playerCount++;
					possibleDefenders.push(i);
				}
			}
			
			//Calculate number of defenders
			var defendersLeft:int = Math.floor(playerCount * 0.3) + 1;
			var excludeAsDefender:Array = new Array();
			
			
			
			//Add defenders
			while (defendersLeft > 0 && playerCount != 0) {
				trace("Possible defenders: " + possibleDefenders);
				
				var newDefenderIndex:int = int(Math.random() * Number(possibleDefenders.length));
				var newDefender:int = possibleDefenders[newDefenderIndex];
				trace("New defender is " + newDefenderIndex + ", actual ID: " + newDefender);
				
				possibleDefenders.splice(newDefenderIndex , 1);
				
				var defender:Defender = new Defender(this, players[newDefender]);
				(players[newDefender] as MoosesPlayer).attachUnit(defender);
				defenders.push(defender);
				trace("Player " + (players[newDefender] as MoosesPlayer).getPlayerName() + ":" + (players[newDefender] as MoosesPlayer).getPlayerId() + " is a defender");
				
				while (!IsTraversable(defender.x, defender.y)) {
					defender.x = (Math.floor(Math.random() * 10) + 12) * 64;
					defender.y = (Math.floor(Math.random() * 9 + 4)) * 64;
				}
				
				defendersLeft--;
			}
			trace("Attackers are: " + possibleDefenders);
				
			//Attach attacker to rest of players
			for (i = 0; i < players.length; i++) {
				
				if (!((players[i] as MoosesPlayer).getAttachedUnit() is Defender)) {
					var attacker:Attacker = new Attacker(this, players[i]);
					(players[i] as MoosesPlayer).attachUnit(attacker);
					attackers.insertAtEnd(attacker);
					trace("Player " + (players[i] as MoosesPlayer).getPlayerName() + ":" + (players[i] as MoosesPlayer).getPlayerId() + " is a attacker");
					
					while (!IsTraversable(attacker.x, attacker.y)) {
						attacker.x = 100;
						attacker.y = Math.random() * (World.HEIGHT - 256) + 128;
					}
				}
			}
			
			var a:Attacker = attackers.firstNode as Attacker;
			var attackerCount:int = 0;
			while (a != null) {
				addChild(a);
				a = a.nextNode as Attacker;
				attackerCount++;
			}
			
			for each (var d:Defender in defenders) {
				addChild(d);
			}
			
			
			
			maximumPoints = attackerCount + attackerCount * 1.5;
			maximumRespawns = attackerCount + attackerCount * 1.5;
			
			currentPoints = 0;
			currentRespawns = 0;
			
			leftText.text = "Respawns left: " + (maximumRespawns - currentRespawns);
			leftText.setTextFormat(largeText);
			
			rightText.text = "Defending life left: " + (maximumPoints - currentPoints);
			rightText.setTextFormat(largeText);
			
			centerText.text = "Deploy your defenses!";
			scoreboardcenter.y = 0;
			centerText.setTextFormat(largeText);
			
			
			gameState = GS_DEPLOY;
			nextGameState = GS_RUNNING;
			timeForPrevGameStateChange = getTimer();
			timeToChangeGameState = getTimer() + 20 * 1000;
			
		}
		public function BeginRunning():void {
			trace("STATE IS NOW GAME RUNNING");
			
			for each (var d:Defender in defenders) {
				(traversableGrid[(d.x / 64) + (d.y / 64) * 30] as Tile).SetTile(Tile.CONCRETE);
			}
			centerText.text = "";
			scoreboardcenter.y = -500;
			centerText.setTextFormat(largeText);
			
			removeChild(unavailableDeployArea);
			
			
			gameState = GS_RUNNING;
			nextGameState = GS_OVER;
			timeForPrevGameStateChange = getTimer();
			timeToChangeGameState = getTimer() + 120 * 1000;
		}
		public function BeginOver():void {
			roundsFinished++;
			
			trace("STATE IS NOW GAME OVER");
			gameState = GS_OVER;
			nextGameState = GS_DEPLOY;
			timeForPrevGameStateChange = getTimer();
			timeToChangeGameState = getTimer() + 15 * 1000;
			
			
			
			scoreboardcenter.y = 0;
			centerText.text = "Game over!";
			if (Number(currentRespawns) / Number(maximumRespawns) > Number(currentPoints) / Number(maximumPoints)) {
				centerText.appendText("\nThe defenders won!");
			} else if (Number(currentRespawns) / Number(maximumRespawns) < Number(currentPoints) / Number(maximumPoints)) {
				centerText.appendText("\nThe attackers won!");
			} else {
				centerText.appendText("\nIt's a ... tie?");
			}
			centerText.setTextFormat(largeText);
			

		}
		public function GetGameState():int {
			return gameState;
		}
		
		public function RespawnAttacker(oldattacker:Attacker):void {
			
			main.BuzzUnit(oldattacker, 500);
			
			oldattacker.GetPlayer().detachUnit();

			var newattacker:Attacker = new Attacker(this, oldattacker.GetPlayer());
			oldattacker.GetPlayer().attachUnit(newattacker);
			attackers.insertAtEnd(newattacker);
			
			currentRespawns++;
			leftText.text = "Respawns left: " + (maximumRespawns - currentRespawns);
			leftText.setTextFormat(largeText);
			
			newattacker.x = 100;
			newattacker.y = oldattacker.y;
			
			
			addChild(newattacker);
			
			if ( (maximumRespawns - currentRespawns) < 0 ) {
				BeginOver();
			}
		}
		public function AttackerScore(oldattacker:Attacker):void {
			
			main.BuzzUnit(oldattacker, 500);
			
			trace("attacker1 " + oldattacker.GetPlayer());
			var newattacker:Attacker = new Attacker(this, oldattacker.GetPlayer());
			trace("attacker2 " + oldattacker.GetPlayer());
			oldattacker.GetPlayer().detachUnit();
			trace("attacker3 " + oldattacker.GetPlayer());
			oldattacker.GetPlayer().attachUnit(newattacker);
			trace("attacker4 " + oldattacker.GetPlayer());
			newattacker.SetHealth(oldattacker.GetHealth());
			trace("attacker5 " + oldattacker.GetPlayer());
			attackers.insertAtEnd(newattacker);
			
			currentPoints++;
			rightText.text = "Defending life left: " + (maximumPoints - currentPoints);
			rightText.setTextFormat(largeText);
			
			newattacker.x = 100;
			newattacker.y = oldattacker.y;
			
			addChild(newattacker);
			
			if ( (maximumPoints - currentPoints) < 0 ) {
				BeginOver();
			}
		}
		public function Update():void
		{

			if (timeToChangeGameState < getTimer() && nextGameState == GS_RUNNING) { BeginRunning(); }
			if (timeToChangeGameState < getTimer() && nextGameState == GS_DEPLOY) { BeginDeploy(); }
			if (timeToChangeGameState < getTimer() && nextGameState == GS_OVER) { BeginOver(); }
			
			
			timerbar.width = ((getTimer()-timeForPrevGameStateChange) /(timeToChangeGameState - timeForPrevGameStateChange)) * 380;
			timerbar.x = 5;
			
			if (lastUpdate < getTimer()) {
				lastUpdate = getTimer() + 1000;
				/*trace("loop 01: fps " + loopTime[0]); loopTime[0] = 0;
				trace("loop 02: att " + loopTime[1]); loopTime[1] = 0;
				trace("loop 03: def " + loopTime[2]); loopTime[2] = 0;
				trace("loop 04: bul " + loopTime[3]); loopTime[3] = 0;
				/*trace("loop 05: " + loopTime[4]); loopTime[4] = 0;
				trace("loop 06: " + loopTime[5]); loopTime[5] = 0;
				trace("loop 07: " + loopTime[6]); loopTime[6] = 0;
				trace("loop 08: " + loopTime[7]); loopTime[7] = 0;
				trace("loop 09: " + loopTime[8]); loopTime[8] = 0;
				trace("loop 10: " + loopTime[9]); loopTime[9] = 0;*/
			}
			
			numFrames++;
			
			t = getTimer();
			if (getTimer() - lastCheck > 1000) {
				lastCheck = getTimer();
				fpsMon.text = numFrames + " FPS.";
				numFrames = 0;
			}
			loopTime[0] += (getTimer() - t); t = getTimer();
			
			var a:Attacker = attackers.firstNode as Attacker;
			while (a != null) {
				a.Update();
				
				if (a.IsAlive()) {
					var caX:int = a.x / 64;
					var caY:int = a.y / 64;
					
					for (var i:int = caX-2; i < caX+2; i++) {
						for (var j:int = caY-2; j < caY+2; j++) {
							if (caX + caY * 30 >= 0 && caX + caY * 30 < mapObjectGrid.length) {
								if (mapObjectGrid[i+j*30] != null) {
									
									tss = mapObjectGrid[i+j*30] as Sprite;
									
									if (a.x > tss.x && a.x < tss.x + 64 && a.y > tss.y && a.y < tss.y + 64) {
										if (mapObjectGrid[i+j*30] is Scorefield) {
											a.Kill();	
											AttackerScore(a);
											particleExplosion(a.x, a.y);
										} else if (mapObjectGrid[i+j*30] is Haste) {
											a.AddBuff(new HasteBuff(a, 60, 5));
											removeChild(mapObjectGrid[i+j*30]);
											particleExplosion(mapObjectGrid[i + j * 30].x + 32, mapObjectGrid[i + j * 30].y + 32);
											mapObjectGrid[i + j * 30] = null;
										}
									}							
								}
							}
						}
					}
				}
				if (a.isReadyForRemoval() && a.removed == false && GetGameState() == GS_RUNNING ) {
					var nextAttackerNode:Attacker = a.nextNode as Attacker;
					a.removed = true;
					removeChild(a);
					attackers.remove(a);
					
					a = nextAttackerNode;
				} else {
					a = a.nextNode as Attacker;
				}
			}
			loopTime[1] += (getTimer() - t); t = getTimer();
			
			
			for each (var d:Defender in defenders) {
				d.Update();
			}
			
			loopTime[2] += (getTimer() - t); t = getTimer();
			
			var b:Bullet = bullets.firstNode as Bullet;
			
			while(b != null) {
				
				if (b.IsAlive()) {
					b.Update();
					
					if (IsBlocking(b.x, b.y) == true) {
						b.Die();
					}
					
					var aa:Attacker = attackers.firstNode as Attacker;
					
					while (aa != null) {
						if (aa.IsAlive()) {
							if (!( aa.x - b.x > 32 || aa.x - b.x < -32 || aa.y - b.y > 32 || aa.y - b.y < -32)) {
								if ( Math.sqrt(  Math.pow(aa.x - b.x, 2) + Math.pow(aa.y - b.y, 2)  ) < 32 ) {
									aa.Damage(b.GetDamage());
									b.Die();
								}
							}
						}

						aa = aa.nextNode as Attacker;
					}
			
				}
				
				
				
				if (b.IsAlive() == false) {
					var nextNode:Bullet = b.nextNode as Bullet;
					bullets.remove(b);
					b = nextNode;
				} else {
					b = b.nextNode as Bullet;
				}
				
				
				
			}
			
			
			
			var p:Particle = particles.firstNode as Particle;
			
			while(p != null) {
				
				p.Update();
				
				if (p.IsDead())
				{
					var nextParticleNode:Particle = p.nextNode as Particle;
					particles.remove(p);
					p = nextParticleNode;
				} else {
					p = p.nextNode as Particle;
				}
				
				
				
			}
			
			
			
			loopTime[3] += (getTimer() - t); t = 0;
			
			
		}
		
	}
	
}