﻿package  no.ekse.elk.buff
{
	import no.ekse.common.LinkedListNode;
	
	/**
	 * ...
	 * @author Magnus Ekse
	 */
	public class HasteBuff implements LinkedListNode, IBuff
	{
		private var life:int = 100;
		private var active:Boolean = true;
		
		private var buffedUnit:IBuffable;
		
		private var value:Number = 1;
		
		
		private var _prevNode:LinkedListNode;
		private var _nextNode:LinkedListNode;
		
		public function HasteBuff(unit:IBuffable, life:int, value:Number) 
		{
			this.life = life;
			buffedUnit = unit;
			this.value = value;
			
			buffedUnit.AddHaste(value);
			
		}
		
		public function IsActive():Boolean {
			return active;
		}
		
		public function Update():void {
			life--;

			if (life < 0 && active) {
				active = false;
				
				buffedUnit.RemoveHaste(value);
				
			}
			
		}
		
		public function get previousNode():LinkedListNode {
			return _prevNode;
		}
		public function set previousNode(value:LinkedListNode):void {
			_prevNode = value;
		}
		
		public function get nextNode():LinkedListNode {
			return _nextNode;
		}
		public function set nextNode(value:LinkedListNode):void{
			_nextNode = value;
		}
		
		public function equals(o:Object):Boolean{
			return o === this;
		}
		
	}
	
}