﻿package  no.ekse.mooses
{
	
	public class MoosesPlayer
	{
		
		//an array holding the current state of all keys
		private var keyState:Array = new Array(16);
		
		private var playerId:int = new int();
		private var playerName:String = new String("Unnamed");
		
		private var attachedUnit:MoosesUnit = null;
		
		private var moosesData:MoosesData;
		
		public function MoosesPlayer(moosesData:MoosesData, playerId:int, playerName:String) 
		{
			this.playerId = playerId;
			this.playerName = playerName;
			this.moosesData = moosesData;
			
			for (var i:int; i < 16; i++) {
				keyState[i] = false;
			}
			
		}
		
		public function attachUnit(unit:MoosesUnit):void {
			attachedUnit = unit;
			attachedUnit.setMoosesPlayer(this);
		}
		public function detachUnit():void {
			if (attachedUnit != null) {
				/*attachedUnit.setMoosesPlayer(new MoosesPlayer(moosesData, 99999, "dummy"));
				attachedUnit.setMoosesPlayer(null);*/
				attachedUnit = null;
			}
		}
		public function getAttachedUnit():MoosesUnit {
			return attachedUnit;
		}
		
		/*  a   b	|  12    13
		 *  1 2 3	|  01 02 03
		 *  4 5 6	|  04 05 06
		 *  7 8 9	|  07 08 09
		 *  * 0 #	|  10 00 11
		 */	
		public function keyDown(keyId:int):void
		{
			keyState[keyId] = true;
			
			if (attachedUnit != null) attachedUnit.keyDown(keyId);
		}
		
		public function keyUp(keyId:int):void
		{
			keyState[keyId] = false;
			
			if (attachedUnit != null) attachedUnit.keyUp(keyId);
		}
		
		public function getKeyState(keyId:int):Boolean {
			return keyState[keyId];
		}
		
		public function getPlayerId():int {
			return playerId;
		}
		public function getPlayerName():String {
			return playerName;
		}
		
		public function sendScore(score:int):void {
			
			moosesData.updatePlayerScore(playerId, score);				
			
		}
		
		public function update():void
		{
			trace("player update");
		}
	}
	
}