﻿package  no.ekse.mooses
{
	import flash.events.Event;
	
	/**
	 * The event which is propagated if a player joins or quits the MOOSES server.
	 * 
	 * @author Magnus Ekse
	 */
	public class MoosesPlayerEvent extends Event 
	{
		public static const MOOSES_PLAYER_JOIN:String = "MoosesPlayerJoin";
		public static const MOOSES_PLAYER_QUIT:String = "MoosesPlayerQuit";
		
		public var playerId:int = -1;
		public var playerName:String = "";
		
		public function MoosesPlayerEvent(type:String, playerId:int, playerName:String, bubbles:Boolean=false, cancelable:Boolean=false) 
		{ 
			super(type, bubbles, cancelable);
			
			this.playerId = playerId;
			this.playerName = playerName;
			
		} 
		
		public override function clone():Event 
		{ 
			return new MoosesPlayerEvent(type, playerId, playerName, bubbles, cancelable);
		} 
		
		public override function toString():String 
		{ 
			return formatToString("MoosesPlayerEvent", "playerId", "playerName", "type", "bubbles", "cancelable", "eventPhase"); 
		}
		
	}
	
}