﻿package no.ekse.productball
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.system.fscommand;
	import flash.utils.getTimer;
	import no.ekse.mooses.MoosesConnectionEvent;
	import no.ekse.mooses.MoosesData;
	import no.ekse.mooses.MoosesFrameworkClient;
	import no.ekse.mooses.MoosesInfo;
	
	/**
	 * ...
	 * @author Magnus Ekse
	 */
	public class Main extends Sprite
	{
		private var field:ProductField;
		
		private var mooses:MoosesFrameworkClient;
		private var moosesLog:MoosesInfo;
		private var moosesData:MoosesData;
		
		public static var DEBUG:Boolean = true;
		
		public function MoosesHandleConnected(e:MoosesConnectionEvent):void {
			field = new ProductField(this);
			addChild(field);
		}
		public function MoosesHandleDisconnected(e:MoosesConnectionEvent):void {
			removeChild(field);
			field = null;
		}
		
		public function Main() 
		{
			
			mooses = new MoosesFrameworkClient();
			moosesLog = new MoosesInfo(mooses);
			moosesData = new MoosesData(mooses);
			
			addChild(moosesLog);
			
			moosesLog.log("Initializing");
			
			
			mooses.connect();
			
			//run in fullscreen
			fscommand("fullscreen", "true");
			
			addEventListener(Event.ENTER_FRAME, HandleEnterFrame);
			
			mooses.addEventListener(MoosesConnectionEvent.MOOSES_CONNECTED, MoosesHandleConnected);
			mooses.addEventListener(MoosesConnectionEvent.MOOSES_DISCONNECTED, MoosesHandleDisconnected);
			
			
			

			
			
			addEventListener(Event.ENTER_FRAME, HandleEnterFrame);

			
			if (Main.DEBUG) {
				field = new ProductField(this);
				addChild(field);
				
				
				moosesData.addPlayer(9011, "Alpha");
				moosesData.addPlayer(9021, "Bravo");
				moosesData.addPlayer(9031, "Charlie");
				
				moosesData.addPlayer(9041, "Delta");
				moosesData.addPlayer(9051, "Echo");
				moosesData.addPlayer(9061, "Foxtrot");
				
				moosesData.addPlayer(9007, "Golf");
				moosesData.addPlayer(9008, "Hotel");
				moosesData.addPlayer(9009, "India");
				
				moosesData.addPlayer(9010, "Juliett");
				moosesData.addPlayer(9011, "Kilo");
				moosesData.addPlayer(9012, "Lima");
				
				moosesData.addPlayer(9013, "Mike");
				moosesData.addPlayer(9014, "November");
				moosesData.addPlayer(9015, "Oscar");
				
				moosesData.addPlayer(9016, "Quebec");
				moosesData.addPlayer(9017, "Romeo");
				moosesData.addPlayer(9018, "Sierra");
				
				moosesData.addPlayer(9019, "Tango");
				moosesData.addPlayer(9020, "Uniform");
				moosesData.addPlayer(9021, "Victor");
			}
			
		}
		
		
		public function getPlayerList():Array {
			return moosesData.getPlayerList();
		}
		
		private function HandleEnterFrame(e:Event):void
		{
			if (field != null) {
				field.boink();
			}
		}
		
	}
	
	
	
}