﻿package no.ekse.productball 
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	
	/**
	 * ...
	 * @author Magnus Ekse
	 */
	public class VoteBar extends Sprite
	{
		private var left:Number;
		private var right:Number;
		private var jump:Number;
		private var numVotes:Number;
		
		private var barWidth:Number;
		private var barHeight:Number;
		
		[Embed(source='res/votebar.png')]
		private static const votebarGfx:Class;
		
		private var votebarSprite:Bitmap;
		
		public function VoteBar() 
		{
			super();
			
			barHeight = 15;
			barWidth = (1024 - 200) / 2;
			
			x = 50;
			y = 50;

			numVotes = 100;
			left = 13;
			right = 63;
			jump = 20;
			
			votebarSprite = new VoteBar.votebarGfx();
			
			votebarSprite.x = barWidth - votebarSprite.width;
			addChild(votebarSprite);
			
			updateBar();
			
		}
		
		private function updateBar():void
		{
		
			graphics.clear();
			alpha = 0.75;
			
			graphics.beginFill(0xFFFFFF);
			graphics.drawRect(0, 0, barWidth, barHeight * 3);
			graphics.endFill();
			
			if (left > 0 && numVotes > 0) {
				graphics.beginFill(0x800000);
				graphics.drawRect(0, 0, (left / numVotes) * barWidth, barHeight);
				graphics.endFill();
			}
			
			if (right > 0 && numVotes > 0) {
				graphics.beginFill(0x000080);
				graphics.drawRect( 0, barHeight, (right / numVotes) * barWidth, barHeight);
				graphics.endFill();
			}
			
			if (jump > 0 && numVotes > 0) {
				graphics.beginFill(0x008000);
				graphics.drawRect( 0, barHeight * 2, (jump / numVotes) * barWidth, barHeight);
				graphics.endFill();
			}
			
		
			//trace(left + "." + right + "." + jump + "." + numVotes + "." + barWidth + "." + barHeight);
			//trace("wololooo");
		}
		
		public function setLeftVotes(val:int):void
		{
			left = val;
			updateBar();
		}
		public function setRightVotes(val:int):void
		{
			right = val;
			updateBar();
		}
		public function setJumpVotes(val:int):void
		{
			jump = val;
			updateBar();
		}
		public function setNumVoters(val:int):void
		{
			numVotes = val;
			updateBar();
		}
		
	}
	
}